
object list;
object ls;
object add;
object delete;
object input;
object hbox;
object vbox;
object select;
//private object hb2,vscroll,vadj; // for the scrolled list

private mapping callbacks=([]);

int allow_duplicates=0;

inherit GTK2.Vbox;


private function check_callback;

void create() {
  ls=GTK2.ListStore(({ "string" }));
  list=GTK2.TreeView(ls);

  select=list->get_selection();
  select->set_mode(GTK2.SelectionSingle);
  select->signal_connect("changed",private_change_row,0);
  object cell=GTK2.CellRendererText();
  object col=GTK2.TreeViewcolumn("IP Address",cell,"text",0);
  list->append_column(col);

  delete=GTK2.Button(" Delete ");
  delete->set_sensitive(0);
  delete->signal_connect("clicked",private_delete_row,0);

  add=GTK2.Button("  Add  ");
  add->signal_connect("clicked",private_add_row,0);

  input=GTK2.Entry();

  hbox=GTK2.Hbox(0,0);
  hbox->pack_start(input,0,0,1);
  hbox->pack_end(delete,0,0,1);
  hbox->pack_end(add,0,0,1);

  ::create(0,0);
  ::pack_start(list, 0,0,0);
  ::pack_end(hbox, 0,0,0);
}

object show() {
  ::show();
  return this_object();
}

object show_all() {
  ::show_all();
  return this_object();
}

array get_contents() {
  array c=({});
  object iter=ls->get_iter_first();
  while (iter) {
    c+=({ list->get_value(iter,0) });
    iter=ls->iter_next(iter);
  }
  return c;
}

void set_contents(array c) {
  if(!c || sizeof(c)==0)
    return 0;
  ls->clear();
  object iter;
  foreach (c, string str) {
    iter=ls->append();
    ls->set_row(iter,({ str }));
  }
}

void get_selection() {

}

void set_selection(array rows) {
  return;
}

int signal_connect(string signal, function callback, mixed|void callback_arg) {
  if (signal=="changed") {
    if (!callbacks->changed)
      callbacks->changed=({});    
    callbacks->changed+=({({callback,callback_arg})});
  } else
    ::signal_connect(signal,callback,callback_arg);
}

void set_allow_duplicates(int yesno) {
  allow_duplicates=yesno;
}

void set_validation_callback(function cb) {
  if (functionp(cb))
    check_callback=cb;
}

private void private_change_row(object t, mixed ... args) {
  array k1=sel->get_selected();
  if (k1[0])
    if (sel->iter_is_selected(k1[0]))
      delete->set_sensitive(1);
    else
      delete->set_sensitive(0);
}
  
private void private_add_row() {
  string res;
  string i=input->get_text();

  if (check_callback && functionp(check_callback))
    res=call_function(check_callback,i);

  if (res || !i) // validation of input failed. display error.
  {
    object gd=GTK2.Dialog();
    gd->add_button(GTK2.STOCK_OK,GTK2.RESPONSE_OK);
    gd->vbox()->add(GTK2.Label(res)->show());
    gd->run();
//    GTKSupport.Alert(res);  
    return;
  }

  if (!allow_duplicates) {
    if (search(get_contents(),i)!=-1) {
      object gd=GTK2.Dialog();
      gd->add_button(GTK2.STOCK_OK,GTK2.RESPONSE_OK);
      gd->vbox()->add(GTK2.Label("An entry for " + i + " already exists.")->show());
      gd->run();
//      GTKSupport.Alert("An entry for " + i + " already exists.");
      return;
    }
  }

  object iter=ls->append();
  ls->set_row(iter,({ i }));
  if (callbacks->changed)
    foreach (callbacks->changed, array cb)
      cb[0](cb[1],this_object(),"+"+i);

  return;
}

private void private_delete_row() {
  array r=list->get_selection();
  if (r && sizeof(r) > 0)
    foreach (r, int row) {
      string d=list->get_text(row,0);
      list->remove(row);
      if (callbacks->changed)
	foreach (callbacks->changed, array cb)
	  cb[0](cb[1],this_object(),"-"+d);
      
    }
}
